# Clutter::LayoutManager Class Reference

Inherits Glib::Object.

Inherited by Clutter::BinLayout, Clutter::Box, Clutter::BoxLayout, Clutter::FixedLayout, and Clutter::FlowLayout.

Collaboration diagram for Clutter::LayoutManager:
[legend]

List of all members.

## Public Member Functions

virtual | ~LayoutManager ()
ClutterLayoutManager* | gobj ()
| Provides access to the underlying C GObject.
const ClutterLayoutManager* | gobj () const
| Provides access to the underlying C GObject.
ClutterLayoutManager* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
template<class PropertyType >
void | set_child_property (const Glib::RefPtr< Container >& container, const Glib::RefPtr< Actor >& child, const Glib::ustring& property_name, const PropertyType&value)
void | set_child_property_value (const Glib::RefPtr< Container >& container, const Glib::RefPtr< Actor >& child, const Glib::ustring& property_name, const Glib::ValueBase&value)
| Sets a property on the Clutter::LayoutMeta created by manager and attached to a child of container.
template<class PropertyType >
void | get_child_property (const Glib::RefPtr< Container >& container, const Glib::RefPtr< const Actor >& actor, const Glib::ustring& property_name, PropertyType&value) const
void | get_child_property_value (const Glib::RefPtr< Container >& container, const Glib::RefPtr< const Actor >& actor, const Glib::ustring& property_name, Glib::ValueBase&value) const
void | get_preferred_width (const Glib::RefPtr< Container >& container, float for_height, float& min_width_p, float& natural_width_p) const
| Computes the minimum and natural widths of the container according to manager.
void | get_preferred_height (const Glib::RefPtr< Container >& container, float for_width, float& min_height_p, float& natural_height_p) const
| Computes the minimum and natural heights of the container according to manager.
void | allocate (const Glib::RefPtr< Container >& container, const ActorBox& box, AllocationFlags absolute_origin_changed)
| Allocates the children of container given an area.
void | set_container (const Glib::RefPtr< Container >& container)
| If the Clutter::LayoutManager sub-class allows it, allow adding a weak reference of the container using manager from within the layout manager.
Glib::RefPtr< Alpha > | begin_animation (guint duration, gulong mode)
| Begins an animation of duration milliseconds, using the provided easing mode.
Glib::RefPtr< const Alpha > | begin_animation (guint duration, gulong mode) const
| Begins an animation of duration milliseconds, using the provided easing mode.
double | get_animation_progress ()
| Retrieves the progress of the animation, if one has been started by begin_animation().
void | end_animation ()
| Ends an animation started by begin_animation().
virtual void | get_preferred_width_vfunc (const Glib::RefPtr< Container >& container, float for_height, float& min_width_p, float& natural_width_p) const
virtual void | get_preferred_height_vfunc (const Glib::RefPtr< Container >& container, float for_width, float& min_height_p, float& natural_height_p) const
virtual void | allocate_vfunc (const Glib::RefPtr< Container >& container, const ActorBox& box, AllocationFlags absolute_origin_changed)
virtual void | set_container_vfunc (const Glib::RefPtr< Container >& container)
virtual GType | get_child_meta_type_vfunc () const
virtual Glib::RefPtr< LayoutMeta > | create_child_meta_vfunc (const Glib::RefPtr< Container >& container, const Glib::RefPtr< Actor >& actor)
virtual Glib::RefPtr< Alpha > | begin_animation_vfunc (guint duration, gulong mode)
virtual double | get_animation_progress_vfunc ()
virtual void | end_animation_vfunc ()
Glib::SignalProxy0< void > | signal_layout_changed ()

## Protected Member Functions

| LayoutManager ()
virtual void | on_layout_changed ()

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr < Clutter::LayoutManager > | wrap (ClutterLayoutManager* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Constructor & Destructor Documentation

virtual Clutter::LayoutManager::~LayoutManager | ( |  | ) | `[virtual]`

Clutter::LayoutManager::LayoutManager | ( |  | ) | `[protected]`

## Member Function Documentation

void Clutter::LayoutManager::allocate | ( | const Glib::RefPtr< Container >& | container,
|  | const ActorBox& | box,
|  | AllocationFlags | absolute_origin_changed |
| ) |  |  |

Allocates the children of container given an area.

See also Clutter::Actor::allocate()

Since cluttermm 1.2:

Parameters:

  | container | The Clutter::Container using manager.
  | allocation | The Clutter::ActorBox containing the allocated area of container.
  | flags | The allocation flags.

virtual void Clutter::LayoutManager::allocate_vfunc | ( | const Glib::RefPtr< Container >& | container,
|  | const ActorBox& | box,
|  | AllocationFlags | absolute_origin_changed |
| ) |  |  | `[virtual]`

Glib::RefPtr<Alpha> Clutter::LayoutManager::begin_animation | ( | guint | duration,
|  | gulong | mode |
| ) |  |  |

Begins an animation of duration milliseconds, using the provided easing mode.

The easing mode can be specified either as a Clutter::AnimationMode or as a logical id returned by Clutter::Alpha::register_func()

The result of this function depends on the manager implementation

Since cluttermm 1.2:

Parameters:

  | duration | The duration of the animation, in milliseconds.
  | mode | The easing mode of the animation.

Returns:
  The Clutter::Alpha created by the layout manager; the returned instance is owned by the layout manager and should not be unreferenced.

Glib::RefPtr<const Alpha> Clutter::LayoutManager::begin_animation | ( | guint | duration,
|  | gulong | mode |
| ) |  |  | const

Begins an animation of duration milliseconds, using the provided easing mode.

The easing mode can be specified either as a Clutter::AnimationMode or as a logical id returned by Clutter::Alpha::register_func()

The result of this function depends on the manager implementation

Since cluttermm 1.2:

Parameters:

  | duration | The duration of the animation, in milliseconds.
  | mode | The easing mode of the animation.

Returns:
  The Clutter::Alpha created by the layout manager; the returned instance is owned by the layout manager and should not be unreferenced.

virtual Glib::RefPtr<Alpha> Clutter::LayoutManager::begin_animation_vfunc | ( | guint | duration,
|  | gulong | mode |
| ) |  |  | `[virtual]`

virtual Glib::RefPtr<LayoutMeta> Clutter::LayoutManager::create_child_meta_vfunc | ( | const Glib::RefPtr< Container >& | container,
|  | const Glib::RefPtr< Actor >& | actor |
| ) |  |  | `[virtual]`

void Clutter::LayoutManager::end_animation | ( |  | ) |

Ends an animation started by begin_animation().

The result of this call depends on the manager implementation

Since cluttermm 1.2:

virtual void Clutter::LayoutManager::end_animation_vfunc | ( |  | ) | `[virtual]`

double Clutter::LayoutManager::get_animation_progress | ( |  | ) |

Retrieves the progress of the animation, if one has been started by begin_animation().

The returned value has the same semantics of the Clutter::Alpha:alpha value

Since cluttermm 1.2:

Returns:
  The progress of the animation.

virtual double Clutter::LayoutManager::get_animation_progress_vfunc | ( |  | ) | `[virtual]`

virtual GType Clutter::LayoutManager::get_child_meta_type_vfunc | ( |  | ) | const`[virtual]`

template <class PropertyType >

void Clutter::LayoutManager::get_child_property | ( | const Glib::RefPtr< Container >& | container,
|  | const Glib::RefPtr< const Actor >& | actor,
|  | const Glib::ustring & | property_name,
|  | PropertyType & | value |
| ) |  |  | const`[inline]`

void Clutter::LayoutManager::get_child_property_value | ( | const Glib::RefPtr< Container >& | container,
|  | const Glib::RefPtr< const Actor >& | actor,
|  | const Glib::ustring & | property_name,
|  | Glib::ValueBase & | value |
| ) |  |  | const

void Clutter::LayoutManager::get_preferred_height | ( | const Glib::RefPtr< Container >& | container,
|  | float | for_width,
|  | float & | min_height_p,
|  | float & | natural_height_p |
| ) |  |  | const

Computes the minimum and natural heights of the container according to manager.

See also Clutter::Actor::get_preferred_height()

Since cluttermm 1.2:

Parameters:

  | container | The Clutter::Container using manager.
  | for_width | The width for which the height should be computed, or -1.
  | min_height_p | Return location for the minimum height of the layout, or `0`.
  | nat_height_p | Return location for the natural height of the layout, or `0`.

virtual void Clutter::LayoutManager::get_preferred_height_vfunc | ( | const Glib::RefPtr< Container >& | container,
|  | float | for_width,
|  | float & | min_height_p,
|  | float & | natural_height_p |
| ) |  |  | const`[virtual]`

void Clutter::LayoutManager::get_preferred_width | ( | const Glib::RefPtr< Container >& | container,
|  | float | for_height,
|  | float & | min_width_p,
|  | float & | natural_width_p |
| ) |  |  | const

Computes the minimum and natural widths of the container according to manager.

See also Clutter::Actor::get_preferred_width()

Since cluttermm 1.2:

Parameters:

  | container | The Clutter::Container using manager.
  | for_height | The height for which the width should be computed, or -1.
  | min_width_p | Return location for the minimum width of the layout, or `0`.
  | nat_width_p | Return location for the natural width of the layout, or `0`.

virtual void Clutter::LayoutManager::get_preferred_width_vfunc | ( | const Glib::RefPtr< Container >& | container,
|  | float | for_height,
|  | float & | min_width_p,
|  | float & | natural_width_p |
| ) |  |  | const`[virtual]`

const ClutterLayoutManager* Clutter::LayoutManager::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented in Clutter::BinLayout, Clutter::BoxLayout, Clutter::FixedLayout, and Clutter::FlowLayout.

ClutterLayoutManager* Clutter::LayoutManager::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented in Clutter::BinLayout, Clutter::BoxLayout, Clutter::FixedLayout, and Clutter::FlowLayout.

ClutterLayoutManager* Clutter::LayoutManager::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented in Clutter::BinLayout, Clutter::BoxLayout, Clutter::FixedLayout, and Clutter::FlowLayout.

virtual void Clutter::LayoutManager::on_layout_changed | ( |  | ) | `[protected, virtual]`

template <class PropertyType >

void Clutter::LayoutManager::set_child_property | ( | const Glib::RefPtr< Container >& | container,
|  | const Glib::RefPtr< Actor >& | child,
|  | const Glib::ustring & | property_name,
|  | const PropertyType & | value |
| ) |  |  | `[inline]`

void Clutter::LayoutManager::set_child_property_value | ( | const Glib::RefPtr< Container >& | container,
|  | const Glib::RefPtr< Actor >& | child,
|  | const Glib::ustring & | property_name,
|  | const Glib::ValueBase & | value |
| ) |  |  |

Sets a property on the Clutter::LayoutMeta created by manager and attached to a child of container.

Since cluttermm 1.2:

Parameters:

  | container | A Clutter::Container using manager.
  | actor | A Clutter::Actor child of container.
  | property_name | The name of the property to set.
  | value | A Value with the value of the property to set.

void Clutter::LayoutManager::set_container | ( | const Glib::RefPtr< Container >& | container | ) |

If the Clutter::LayoutManager sub-class allows it, allow adding a weak reference of the container using manager from within the layout manager.

The layout manager should not increase the reference count of the container

Since cluttermm 1.2:

Parameters:

  | container | A Clutter::Container using manager.

virtual void Clutter::LayoutManager::set_container_vfunc | ( | const Glib::RefPtr< Container >& | container | ) | `[virtual]`

Glib::SignalProxy0< void > Clutter::LayoutManager::signal_layout_changed | ( |  | ) |

Prototype:
  `void on_my_layout_changed()`

## Friends And Related Function Documentation

Glib::RefPtr< Clutter::LayoutManager > wrap | ( | ClutterLayoutManager * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- cluttermm/layout-manager.h